/** INF100, ving 7, oppgave 8.2.
 *  Forbedret boblesortering: sorteringen avbrytes dersom ingen
 *  ombyttinger har skjedd i lpet av en iterasjon.
 */
class BedreBobleSortering { 
    public static void main(String[] args) {
        int[] tall = { 2, 3, 8, 6, 5, 7 };
        skrivTabell(tall, "Usortert tabell: ");
        sorter(tall);
        skrivTabell(tall, "Etter boblesortering: ");
    }
    public static void sorter(int[] tall) {
	// Flagget byttet indikerer om bytting har skjedd i en iterasjon	
	boolean byttet = true; // fordi vi vil uansett utfre frste iterasjon
        // For hvert gjennomlp:
        for (int siste=tall.length-1; siste>0 && byttet; siste--) {
	    byttet = false; // ny iterasjon, ingen bytting har skjedd enn
            // For hvert nabopar i usortert del av tabellen:
            for (int dette=0; dette<siste; dette++) {
                // Hvis verdier i nabopar str i feil rekkeflge:
                //     Bytt om verdier i nabopar
                if (tall[dette] > tall[dette+1]) {
                    int temp = tall[dette];
                    tall[dette] = tall[dette+1];
                    tall[dette+1] = temp;
		    byttet = true;
                }
            }
            skrivTabell(tall, (tall.length-siste)+". gjennomlp: ");
        }
    }
    public static void skrivTabell(int[] tab, String ledetekst) {
        System.out.print(ledetekst);
        for (int i=0; i<tab.length; i++) System.out.print(tab[i] + "  ");
        System.out.println();
    }
}
