class Vare {
    private String navn;
    private double pris;
    private boolean moms = false;
    static final double MOMS = 0.24;

    public Vare(String vareNavn, double basisPris) {
        navn = vareNavn;
        pris = basisPris;
    }

    public void settMoms(boolean momspliktig) {
        moms = momspliktig;
    }

    public String hentNavn() {
        return navn;
    }

    public double hentUtsalgspris() {
        if (moms)
            return pris * (1 + MOMS);
        else
            return pris;
    }
}
